"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var common_1 = require("./common");
var middleware = require("./middleware");
function init() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _a, tmpl, variables, dir, alerts$, task, error_1;
        var _this = this;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    common_1.log.info();
                    common_1.log.info.gray("\uD83D\uDC4B");
                    return [4, prepareTemplate({})];
                case 1:
                    _a = _b.sent(), tmpl = _a.tmpl, variables = _a.variables, dir = _a.dir;
                    if (!tmpl || !dir || !variables) {
                        return [2];
                    }
                    alerts$ = tmpl.events$.pipe(operators_1.filter(function (e) { return e.type === 'TMPL/alert'; }), operators_1.map(function (e) { return e.payload; }));
                    task = {
                        title: 'Setup',
                        task: function () {
                            return new rxjs_1.Observable(function (observer) {
                                alerts$.subscribe(function (e) { return observer.next(e.message); });
                                (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                    return tslib_1.__generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4, tmpl.execute({ variables: variables })];
                                            case 1:
                                                _a.sent();
                                                observer.complete();
                                                return [2];
                                        }
                                    });
                                }); })();
                            });
                        },
                    };
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, , 5]);
                    common_1.log.info();
                    return [4, common_1.cli.exec.tasks.run(task)];
                case 3:
                    _b.sent();
                    common_1.log.info();
                    logComplete({ dir: dir });
                    return [3, 5];
                case 4:
                    error_1 = _b.sent();
                    common_1.log.error(error_1);
                    return [3, 5];
                case 5:
                    common_1.log.info();
                    return [2];
            }
        });
    });
}
exports.init = init;
function prepareTemplate(args) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var template, moduleName, res, res, rename, tmpl, dir, variables;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    template = args.template, moduleName = args.moduleName;
                    if (!!moduleName) return [3, 2];
                    return [4, common_1.cli.prompt.text({ message: 'Module name' })];
                case 1:
                    res = _a.sent();
                    if (!res) {
                        return [2, {}];
                    }
                    moduleName = res;
                    _a.label = 2;
                case 2:
                    if (!!template) return [3, 4];
                    return [4, common_1.cli.prompt.radio({
                            message: 'Template',
                            items: [
                                { name: '@platform toolchain', value: 'platform' },
                            ],
                        })];
                case 3:
                    res = _a.sent();
                    if (!res) {
                        return [2, {}];
                    }
                    template = res;
                    _a.label = 4;
                case 4:
                    rename = [{ from: 'pkg.json', to: 'package.json' }];
                    tmpl = common_1.Template
                        .create(path_1.join(__dirname, '../templates/base'))
                        .use(middleware.processPackage({ filename: 'pkg.json' }))
                        .use(middleware.saveFile({ rename: rename }))
                        .use(middleware.npmInstall())
                        .use(middleware.runInitCommand({ template: template, done: 'COMPLETE' }));
                    dir = path_1.resolve("./" + moduleName);
                    variables = {
                        template: template,
                        platform: ['ELECTRON', 'WEB'],
                        moduleName: moduleName,
                        dir: dir,
                    };
                    return [2, { tmpl: tmpl, variables: variables, dir: dir }];
            }
        });
    });
}
function logComplete(args) {
    var dir = path_1.basename(args.dir);
    common_1.log.info.gray('🖐  To start your development server:\n');
    common_1.log.info.cyan("     cd " + common_1.log.white(dir));
    common_1.log.info.cyan("     yarn start");
    common_1.log.info();
    common_1.log.info.gray('👉  To see all available UIHarness commands:\n');
    common_1.log.info.cyan("     cd " + common_1.log.white(dir));
    common_1.log.info.cyan("     yarn ui");
    common_1.log.info();
    common_1.log.info.gray("See " + common_1.log.blue('https://uiharness.com') + " for more.\n");
    common_1.log.info();
}
